> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-ui-builder/17.latest/filtering/data-views.md).

# Data Views

Learn how to configure data views in Umbraco UI Builder.

Data views allow you to define multiple pre-filtered views of the same data source. This is useful when entities exist in different states and you need a way to toggle between them.

![Data Views](https://2099605805-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FXdAOUcqxoBqXe5oCQF8z%2Fuploads%2Fgit-blob-c577f854dc52c44a5bc81a7e8f072a8d52d2cadb%2Fdata_views.png?alt=media)

## Defining Data Views

Data views are defined via the [Collections](/umbraco-ui-builder/17.latest/collections/overview.md) settings.

### Using the `AddDataView()` Method

Creates a data view with the specified name and a where clause filter expression. The expression must return a `boolean` value.

#### Method Syntax

```cs
AddDataView(string name, Lambda whereClauseExpression) : CollectionConfigBuilder<TEntityType>
```

#### Example

```csharp
collectionConfig.AddDataView("Active", p => p.IsActive);
```

### Using the `AddDataView()` Method with Group

Creates a data view within a specified group, using a where clause filter expression. The expression must return a `boolean` value.

#### Method Syntax

```cs
AddDataView(string group, string name, Lambda whereClauseExpression) : CollectionConfigBuilder<TEntityType>
```

#### Example

```csharp
collectionConfig.AddDataView("Status", "Active", p => p.IsActive);
```

### Using the `AddAllDataView` Method

Enables the `All` option for data views in the collection. The method can take an empty string, which will display the CMS localized `All` value, plain text, or a localized string.

By default, the `All` option is not selected initially if other data views are also defined, in this case the first `AddDataView()` view is selected instead. Set `isDefault` to `true` to make `All` the initially selected view.

#### Method Syntax

```cs
collectionConfig.AddAllDataView(string? label, bool isDefault = false)
```

#### Example

```csharp
collectionConfig.AddAllDataView("All", isDefault: true);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.umbraco.com/umbraco-ui-builder/17.latest/filtering/data-views.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
